<?php
/*
Plugin Name: BillyBenRing
Plugin URI: http://www.etherocliquecite.eu
Description: BillyBenRing display your links, tag and/or categories by a circlar sideBar widget, with full or arrowed circles. Fully customizable. Multi Instance.
Author: Billyben
Version: 2.0.0
Author URI: http://asblog.etherocliquecite.eu
*/

/* inclu les utilitaires */
include("elm/utilsClasse.php");//fct util
include("elm/WPMenuBBR.php");//description du menu
/**
 * BillyBenRing Class
 */
class BillyBenRing extends WP_Widget {
	
	
    /** constructor */
    function BillyBenRing() {
        parent::WP_Widget(false, $name = 'BillyBenRing');	
    }

    function widget($args, $options) {		
        extract( $args );
		$options= bbr_init_single_widget_options($options);
		$general_opt=bbr_init_options(get_option('bbr_options'));
        $title = apply_filters('widget_title', $options['title']);
		// pour le swfObjet
		  $wSize=$options['width'];
		  $hSize=$options['height'];
		  $path=get_bloginfo('wpurl')."/wp-content/plugins/BillyBenRing/" ;
		  // creation des flash var
		  $flashVar['ringSize']=$options['ringSize'];
		  $flashVar['firstRingSize']=$options['firstRingSize'];
		  $flashVar['transparent']=$options['transparent'];
		  if(!$options['transparent'])$flashVar['bgColor']=$options['bgColor'];
		  $flashVar['txtOffColor']= $options['txtOffColor'];
		  $flashVar['txtOnColor']= $options['txtOnColor'];
		  $flashVar['overGlowColor']= $options['overGlowColor'];
		  $flashVar['deltaRing']= $options['deltaRing'];
		  $flashVar['RingCrop']= $options['RingCrop'];
		  $flashVar['startAlign']=$options['startAlign'];		 
		  $flashVar['startAngle']=$options['startAngle'];
		  $flashVar['decalAngle']=$options['decalAngle'];
		  $flashVar['textAlign']= $options['textAlign'];
		  
		  $flashVar['link_dest']= $general_opt['link_dest'];
		  $flashVar['cat_dest']= $general_opt['cat_dest'];
		  $flashVar['tag_dest']= $general_opt['tag_dest'];
		  $flashVar['page_dest']= $general_opt['page_dest'];
		  
		  $flashVar['xmlString']=bbr_getXML_String($options);
		  
		  // la string html
		  $flashHTML=$before_widget;
		  if ( $title )$flashHTML.=$before_title . $title . $after_title;
		  $flashHTML.='<script type="text/javascript" src="'.$path.'elm/js/swfobject.js"></script>
		<script type="text/javascript">
			var flashvars ={};';
		foreach ($flashVar as $key=>$value){
			    $flashHTML.='flashvars.'.$key.'="'.$value.'";';
			}
	$flashHTML.='var params = {allowScriptAccess:"always"};
			params.scale="exactfit";';
	if($options['transparent']){
			$flashHTML.='params.wmode="transparent";';
	}else{		
	$flashHTML.='params.bgcolor="#'.$options['bgColor'].'";';
	}
	$flashHTML.='var attributes = {};
			attributes.align = "middle";
			attributes.id = "'.$this->get_field_id('flashContentId').'";
			swfobject.embedSWF("'.$path.'BillyBenRing.swf", "'.$this->get_field_id('flashContentId').'", "'.$wSize.'", "'.$hSize.'", "10.0.0", false, flashvars, params, attributes);';
	
		$flashHTML.='</script>';
	$flashHTML.=' <div id="'.$this->get_field_id('flashContentId').'">';
	 $flashHTML.='<div id="'.$this->get_field_id('myAlternativeContent').'">	  
			<a href="http://www.adobe.com/go/getflashplayer">
				<img src="http://www.adobe.com/images/shared/download_buttons/get_flash_player.gif" alt="Get Adobe Flash player" />
			</a>
		</div></div>';        
		$flashHTML.=$after_widget;
		echo  $flashHTML;
    }

    function update($new_instance, $old_instance) {				
		$instance = $old_instance;
		foreach($new_instance as $key=>$value){
			$instance[$key] = strip_tags($new_instance[$key]);
		}		
		$instance['displayLink']=($new_instance['displayLink'])?true:false;
		$instance['displayLinkTag']=(strip_tags($new_instance['displayLinkTag']))?true:false;
		$instance['displayCat']=(strip_tags($new_instance['displayCat']))?true:false;
		$instance['displayKeyWord']=(strip_tags($new_instance['displayKeyWord']))?true:false;
		$instance['displayPage']=(strip_tags($new_instance['displayPage']))?true:false;
		$instance['transparent']=(!strip_tags($new_instance['transparent']))?true:false;
		return $instance;
    }

    function form($options) {				
        $title = esc_attr($options['title']);	
		$options=bbr_init_single_widget_options($options);	
		$pageStr='<p>
          <label for='.$this->get_field_id('title').'>'._e('Title:').'</label> 
          <input class="widefat" id="'.$this->get_field_id('title').'" name="'.$this->get_field_name('title').'" type="text" value="'.$title.'" />
        </p>';		
		
		// les options
		$pageStr.= '<p>'.__("Width/Height", "bbr_widget").' :
		<input type="text" name="'.$this->get_field_name('width').'" value="'.$options['width'].'" size="3"></input>
		<input type="text" name="'.$this->get_field_name('height').'" value="'.$options['height'].'" size="3"></input>
		<font size="1">'.__("pixels", "bbr_widget").'</font></p>';
		$pageStr.= '<p>'.__("Ring thickness", "bbr_widget").' :
		<input type="text" name="'.$this->get_field_name('ringSize').'" value="'.$options['ringSize'].'" size="3"></input></p>';
		$pageStr.= '<p>'.__("1st Ring inner radius", "bbr_widget").' :
		<input type="text" name="'.$this->get_field_name('firstRingSize').'" value="'.$options['firstRingSize'].'" size="3"></input></p>';
		$pageStr.= '<p>'.__("BackGround", "bbr_widget").' :
		<input name="'.$this->get_field_name('transparent').'" id="'.$this->get_field_id('transparent').'" type="checkbox"  '.((!$options['transparent'])?"checked":"").' onclick="bbr_check_bgColor(this.id, this.checked)"/>
		<input size="6" name="'.$this->get_field_name("bgColor").'" id="'.$this->get_field_id('bgColor').'" class="color" 
		type='.(($options['transparent'])?"hidden":"text").' value="'.$options['bgColor'].'"/></p>';
       $pageStr.= '<p>'.__("Text Color(Off/Over)", "bbr_widget").':<p/>
	   <input size="6" class="color" type="text" name="'.$this->get_field_name('txtOffColor').'" value="'.$options['txtOffColor'].'"/>
	<input size="6" class="color" type="text" name="'.$this->get_field_name('txtOnColor').'" value="'.$options['txtOnColor'].'"/></p>';
	    $pageStr.= '<p>'.__("Ring Glow Color", "bbr_widget").' :
		<input size="6" class="color" type="text" name="'.$this->get_field_name('overGlowColor').'" value="'.$options['overGlowColor'].'"/></p>';
		$pageStr.= '<p>'.__("Space between rings", "bbr_widget").' :
		<input size="6" id="deltaRing" type="text" name="'.$this->get_field_name('deltaRing').'" size="6" value="'.$options['deltaRing'].'"/></p>';
		
		
		$pageStr.= '<table><td>'.__("Ring fit text", "bbr_widget").':</td> 
		<td><input type="radio" name="'.$this->get_field_name('RingCrop').'" value="ENTIRE" '.(($options['RingCrop']=='ENTIRE')?"checked":"").'> '.__("Entire", "bbr_widget").'<br>
		<input type="radio" name="'.$this->get_field_name('RingCrop').'" value="FIT" '.(($options['RingCrop']=='FIT')?"checked":"").'> '.__("Fit", "bbr_widget").'</td></table>';
		$pageStr.= '<p>'.__("Start Angle", "bbr_widget").' :
	<input type="Text" name="'.$this->get_field_name('startAngle').'" id="startAngle" size="4" value="'.$options['startAngle'].'"/></p>';
		$pageStr.= '<table><td>'.__("Start Alignt", "bbr_widget").':</td>
		<td><input type="radio" name="'.$this->get_field_name('startAlign').'" value="ALIGN" '.(($options['startAlign']=='ALIGN')?"checked":"").'> '.__("Align", "bbr_widget").'<br>
				<input type="radio" name="'.$this->get_field_name('startAlign').'" value="DECAL" '.(($options['startAlign']=='DECAL')?"checked":"").'> '.__("Decal", "bbr_widget").'					
				<input type="Text" name="'.$this->get_field_name('decalAngle').'" id="decalAngle" size="4" value="'.$options['decalAngle'].'"/>				
				<br>
				<input type="radio" name="'.$this->get_field_name('startAlign').'" value="RANDOM" '.(($options['startAlign']=='RANDOM')?"checked":"").'> '.__("Random", "bbr_widget").'<br>				
				</td></table>';
		
	$pageStr.= '<table><td>'.__("Text Direction", "bbr_widget").' :</td><td >
		<input type="radio" name="'.$this->get_field_name('textAlign').'" value="0" '.(($options['textAlign']==0)?"checked":"").'> '.__("In", "bbr_widget").'<br>
		<input type="radio" name="'.$this->get_field_name('textAlign').'" value="1" '.(($options['textAlign']==1)?"checked":"").'> '.__("Along left", "bbr_widget").'<br>
		<input type="radio" name="'.$this->get_field_name('textAlign').'" value="2" '.(($options['textAlign']==2)?"checked":"").'> '.__("Out", "bbr_widget").'<br>
		<input type="radio" name="'.$this->get_field_name('textAlign').'" value="3" '.(($options['textAlign']==3)?"checked":"").'> '.__("Along Right", "bbr_widget").'<br>
	</td></table>';
	// le choix des type à afficher
	
	$pageStr.= '<table class="form-table">';
	$pageStr.= '<tr valign="top"><th scope="row">'.__("What to show", "bbr_widget").'</th></tr>';
	
	$pageStr.= '<td><input name="'.$this->get_field_name('displayLink').'" size="6" type="checkBox" '.(($options['displayLink'])?"checked":"").'>'.__("Display links", "bbr_widget").'</input><strong>  </strong>
			<input name="'.$this->get_field_name('displayLinkTag').'" size="6" type="checkBox" '.(($options['displayLinkTag'])?"checked":"").'>'.__("Display links Tag", "bbr_widget").'</input></td></tr>';
	$pageStr.= '<td><input name="'.$this->get_field_name('displayCat').'" size="6" id="displayCat" type="checkBox" '.(($options['displayCat'])?"checked":"").' >'.__("Display Categories", "bbr_widget").'</input></td></tr>';
	$pageStr.= '<td>
	<input name="'.$this->get_field_name('displayKeyWord').'" size="6" type="checkBox" '.(($options['displayKeyWord'])?"checked":"").'>'.__("Display Tags", "bbr_widget").'</input></td></tr>';
	$pageStr.= '<td>
	<input name="'.$this->get_field_name('displayPage').'" size="6" type="checkBox" '.(($options['displayPage'])?"checked":"").' >'.__("Display Pages", "bbr_widget").'</input></td></tr>';	
	$pageStr.= '</table>';
	
		
		
	   
	   // Javascript
	   //le js color
	   $pageStr.= '<script type="text/javascript" src="'.get_bloginfo('wpurl').'/wp-content/plugins/BillyBenRing/elm/js/jscolor.js">
       </script>';
	   $pageStr.= '<script type="text/javascript">
	   jscolor.init();
	   function bbr_check_bgColor(id, value){
		   var colorId=id.substring(0,id.lastIndexOf("-")+1);
		   var bgCol=document.getElementById(colorId+"bgColor");
		   bgCol.type=(value)?"text":"hidden";
		   
		   }
	   
	   
	   
	   
	   </script>';
	   
	    echo $pageStr;    
    }
} // class BillyBenRing


//
function bbr_install () {
	$options=get_option('bbr_options');
	$options= bbr_init_options($options);
	add_option('bbr_options', $options);	
}
function bbr_uninstall(){
	delete_option('bbr_options');
}


function BillyBenRing_widget()
{ 
  register_widget("BillyBenRing");
}
add_action("widgets_init", "BillyBenRing_widget");
add_action('admin_menu', 'bbr_init_menu');
register_activation_hook( __FILE__, 'bbr_install' );
register_deactivation_hook( __FILE__, 'bbr_uninstall' );

?>
